<?php
/*  zingiri_forum.php
 Copyright 2008,2009 Erik Bogaerts
 Support site: http://www.zingiri.com

 This file is part of Zingiri Forum.

 Zingiri Forum is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 Zingiri Forum is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Zingiri Forum; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
?>
<?php
/*
 Plugin Name: Zingiri Forum
 Plugin URI: http://www.zingiri.com/Forum
 Description: Zingiri Forum is a plugin that integrates the powerfull myBB bulletin board software with Wordpress. It brings one of the most powerfull free forum softwares in reach of Wordpress users.

 Author: EBO
 Version: 1.0.9
 Author URI: http://www.zingiri.com/
 */
define("ZING_FORUM_VERSION","1.0.9");
define("ZING_MYBB","mybb");
define("ZING_MYBB_VERSION","1.4.13");

// Pre-2.6 compatibility for wp-content folder location
if (!defined("WP_CONTENT_URL")) {
	define("WP_CONTENT_URL", get_option("siteurl") . "/wp-content");
}
if (!defined("WP_CONTENT_DIR")) {
	define("WP_CONTENT_DIR", ABSPATH . "wp-content");
}

if (!defined("ZING_FORUM_PLUGIN")) {
	$zing_forum_plugin=str_replace(realpath(dirname(__FILE__).'/..'),"",dirname(__FILE__));
	$zing_forum_plugin=substr($zing_forum_plugin,1);
	define("ZING_FORUM_PLUGIN", $zing_forum_plugin);
}
//$zing_footers[]=array('http://www.mybboard.net/','MyBB');

define("ZING_FORUM_URL", WP_CONTENT_URL . "/plugins/".ZING_FORUM_PLUGIN."/");

define("ZING_MYBB_URL",ZING_FORUM_URL.ZING_MYBB);

$zing_forum_version=get_option("zing_forum_version");
if ($zing_forum_version) {
	add_action("init","zing_forum_init");
	if (get_option('zing_forum_footer')=='Site') add_filter('wp_footer','zing_footers');
	add_filter('the_content', 'zing_forum_content', 10, 3);
	add_action('wp_head','zing_forum_header');
	if (get_option("zing_forum_login")=="WP") {
		add_action('wp_login','zing_forum_login');
		add_action('wp_logout','zing_forum_logout');

		add_filter('check_password','zing_forum_check_password',10,4);
		add_action('profile_update','zing_forum_profile_update'); //post wp update
		add_action('user_register','zing_forum_user_register'); //post wp update
		add_action('delete_user','zing_forum_user_delete');
		/*
		 add_action('user_profile_update_errors','zing_profile_check_errors',10,3); //check errors after wp checks done
		 add_action('show_user_profile','zing_profile_show');
		 add_action('edit_user_profile','zing_profile_edit');
		 add_action('delete_user','zing_delete_user');
		 */
	}

}
register_activation_hook(__FILE__,'zing_forum_activate');
register_deactivation_hook(__FILE__,'zing_forum_deactivate');

require_once(dirname(__FILE__) . '/includes/errorlog.class.php');
require_once(dirname(__FILE__) . '/includes/shared.inc.php');
require_once(dirname(__FILE__) . '/includes/http.class.php');
require_once(dirname(__FILE__) . '/includes/footer.inc.php');
require_once(dirname(__FILE__) . '/includes/integrator.inc.php');
require_once(dirname(__FILE__) . '/forum_cp.php');

$zErrorLog=new zErrorLog();

function zing_forum_check() {
	global $wpdb;
	$errors=array();
	$warnings=array();
	$files=array();
	$dirs=array();

	//$files[]=dirname(__FILE__).'/'.ZING_MYBB.'/inc/settings.php';
	foreach ($files as $file) {
		if (!is_writable($file)) $warnings[]='File '.$file.' is not writable, please chmod to 666';
	}

	$dirs[]=dirname(__FILE__).'/cache';
	foreach ($dirs as $file) {
		if (!is_writable($file)) $errors[]='Directory '.$file.' is not writable, please chmod to 777';
	}

	if (phpversion() < '5')	$warnings[]="You are running PHP version ".phpversion().". We recommend you upgrade to PHP 5.3 or higher.";
	if (ini_get("zend.ze1_compatibility_mode")) $warnings[]="You are running PHP in PHP 4 compatibility mode. We recommend you turn this option off.";
	if (!function_exists('curl_init')) $errors[]="You need to have cURL installed. Contact your hosting provider to do so.";
	else {
		ob_start();
		$c=new HTTPRequest(ZING_MYBB_URL.'/zingiri.php');
		if (!$c->checkConnection()) $errors[]='Can\'t connect to MyBB sub folders, please check your .htaccess file.';
	}
	if (!session_id()) $errors[]='Sessions are not working on your installation, make sure they are turned on.';
	return array('errors'=> $errors, 'warnings' => $warnings);
}


/**
 * Activation: creation of database tables & set up of pages
 * @return unknown_type
 */
function zing_forum_activate() {
	//nothing much to do
}

function zing_forum_install() {
	global $wpdb,$zErrorLog,$current_user;

	$eaw=zing_forum_check();
	if (count($eaw['errors']) > 0) return false;

	ob_start();
	$zErrorLog->clear();
	set_error_handler(array($zErrorLog,'log'));
	error_reporting(E_ALL & ~E_NOTICE);

	if (get_option('zing_forum_mybb_dbname')) {
		$prefix = get_option('zing_forum_mybb_dbprefix');
	} else {
		$prefix = $wpdb->prefix."zing_mybb_";
	}

	$zing_forum_version=get_option("zing_forum_version");
	if (!$zing_forum_version)
	{
		add_option("zing_forum_version",ZING_FORUM_VERSION);
	}
	else
	{
		update_option("zing_forum_version",ZING_FORUM_VERSION);
	}

	//first installation of MyBB
	if (!$zing_forum_version) {
		if (get_option('zing_forum_mybb_dbname')=='') {
			$zErrorLog->msg('Install forum');
			zing_forum_mybb_install();
		} else {
			$zErrorLog->msg('Connect forum');
			$wpdb->select(get_option('zing_forum_mybb_dbname'));
			$query="update ".get_option('zing_forum_mybb_dbprefix')."settings set value='".ZING_MYBB_URL."' where name='bburl'";
			$wpdb->query($query);
			$query="update ".get_option('zing_forum_mybb_dbprefix')."settings set value='' where name='cookiedomain'";
			$wpdb->query($query);
			$user_login=get_option('zing_forum_admin_login');//$current_user->data->user_login;
			$user_pass=zing_forum_admin_password();
			$salt=create_sessionid(8);
			$loginkey=create_sessionid(50);
			$password=md5(md5($salt).md5($user_pass));
			$query2=sprintf("UPDATE `".get_option('zing_forum_mybb_dbprefix')."users` SET `salt`='%s',`loginkey`='%s',`password`='%s' WHERE `username`='%s'",$salt,$loginkey,$password,$user_login);
			$zErrorLog->msg($query2);
			$wpdb->query($query2);
			$wpdb->select(DB_NAME);
		}
		update_option("zing_mybb_version",ZING_MYBB_VERSION);
	}
	//upgrade MyBB if needed
	elseif (get_option("zing_mybb_version") != ZING_MYBB_VERSION) {
		$zErrorLog->msg('Upgrade forum');
		zing_forum_mybb_upgrade();
		update_option("zing_mybb_version",ZING_MYBB_VERSION);
	}

	//upload Zingiri theme and stylesheets
	if ($handle = opendir(dirname(__FILE__).'/db')) {
		$files=array();
		while (false !== ($file = readdir($handle))) {
			if (strstr($file,".sql")) {
				$f=explode("-",$file);

				$v=str_replace(".sql","",$f[1]);
				if ($zing_forum_version < $v) {
					$files[]=dirname(__FILE__).'/db/'.$file;
				}
			}
		}
		closedir($handle);
		asort($files);
		if (count($files) > 0) {
			if (get_option('zing_forum_mybb_dbname')) $wpdb->select(get_option('zing_forum_mybb_dbname'));
			foreach ($files as $file) {
				$file_content = file($file);
				$query = "";
				foreach($file_content as $sql_line) {
					$tsl = trim($sql_line);
					if (($sql_line != "") && (substr($tsl, 0, 2) != "--") && (substr($tsl, 0, 1) != "#")) {
						$sql_line = str_replace("CREATE TABLE `", "CREATE TABLE `".$prefix, $sql_line);
						$sql_line = str_replace("CREATE TABLE IF NOT EXISTS `", "CREATE TABLE `".$prefix, $sql_line);
						$sql_line = str_replace("INSERT INTO `", "INSERT INTO `".$prefix, $sql_line);
						$sql_line = str_replace("ALTER TABLE `", "ALTER TABLE `".$prefix, $sql_line);
						$sql_line = str_replace("UPDATE `", "UPDATE `".$prefix, $sql_line);
						$sql_line = str_replace("TRUNCATE TABLE `", "TRUNCATE TABLE `".$prefix, $sql_line);
						$query .= $sql_line;

						if(preg_match("/;\s*$/", $sql_line)) {
							$zErrorLog->msg($query);
							$wpdb->query($query);
							$query = "";
						}
					}
				}
			}
			if (get_option('zing_forum_mybb_dbname')) $wpdb->select(DB_NAME);
		}
	}

	//create pages
	$zErrorLog->msg('Creating pages');
	if (!$zing_forum_version) {
		$pages=array();
		$pages[]=array("Forum","forum","*",0);

		$ids="";
		foreach ($pages as $i =>$p)
		{
			$my_post = array();
			$my_post['post_title'] = $p['0'];
			$my_post['post_content'] = '';
			$my_post['post_status'] = 'publish';
			$my_post['post_author'] = 1;
			$my_post['post_type'] = 'page';
			$my_post['menu_order'] = 100+$i;
			$my_post['comment_status'] = 'closed';
			$id=wp_insert_post( $my_post );
			if (empty($ids)) { $ids.=$id; } else { $ids.=",".$id; }
			if (!empty($p[1])) add_post_meta($id,'zing_forum_page',$p[1]);
		}
		if (get_option("zing_forum_pages"))
		{
			update_option("zing_forum_pages",$ids);
		}
		else {
			add_option("zing_forum_pages",$ids);
		}
	}

	//login configuration
	if (get_option('zing_forum_mybb_dbname')) $wpdb->select(get_option('zing_forum_mybb_dbname'));
	if (get_option("zing_forum_login")=="MyBB") {
		$user_login=get_option('zing_forum_admin_login');//$current_user->data->user_login;
		$user_pass=zing_forum_admin_password();//get_option("zing_forum_admin_password");
		$salt=create_sessionid(8);
		$loginkey=create_sessionid(50);
		$password=md5(md5($salt).md5($user_pass));
		$query2=sprintf("UPDATE `".$prefix."users` SET `salt`='%s',`loginkey`='%s',`password`='%s' WHERE `username`='%s'",$salt,$loginkey,$password,$user_login);
		$zErrorLog->msg($query2);
		$wpdb->query($query2);
	} else {
		$query2="UPDATE `".$prefix."settings` SET `value`='0' WHERE `name`='failedlogintime'";
		$zErrorLog->msg($query2);
		$wpdb->query($query2);
		$query2="UPDATE `".$prefix."settings` SET `value`='0' WHERE `name`='failedlogincount'";
		$zErrorLog->msg($query2);
		$wpdb->query($query2);
	}
	if (get_option('zing_forum_mybb_dbname')) $wpdb->select(DB_NAME);

	restore_error_handler();

	return true;
}

function zing_forum_hash() {
	return filemtime(dirname(__FILE__).'/'.ZING_MYBB.'/install/lock');
}

function zing_forum_mybb_install() {
	global $wpdb,$zErrorLog,$current_user;
	//'license';
	//'requirements_check';
	//'database_info';
	//create tables
	$post['action']='create_tables';
	$post['zing']=zing_forum_hash();
	$post['dbengine']='mysql';
	$post['config']['mysql']['dbhost']=DB_HOST;
	$post['config']['mysql']['dbuser']=DB_USER;
	$post['config']['mysql']['dbpass']=DB_PASSWORD;
	$post['config']['mysql']['dbname']=DB_NAME;
	$post['config']['mysql']['tableprefix']=$wpdb->prefix.'zing_mybb_';
	$post['config']['mysql']['encoding']=DB_CHARSET;
	$http=zing_forum_http("mybb",'install/index.php');
	$zErrorLog->msg($http);
	$news = new HTTPRequest($http);
	$news->post=$post;
	if ($news->live()) {
		$output=$news->DownloadToString(true,false);
		$zErrorLog->msg('out='.$output);
	}

	//populate tables
	$post['action']='populate_tables';
	$post['zing']=zing_forum_hash();
	$http=zing_forum_http("mybb",'install/index.php');
	$zErrorLog->msg($http);
	$news = new HTTPRequest($http);
	$news->post=$post;
	if ($news->live()) {
		$output=$news->DownloadToString(true,false);
		$zErrorLog->msg('out='.$output);
	}

	//insert templates
	$post['action']='templates';
	$post['zing']=zing_forum_hash();
	$http=zing_forum_http("mybb",'install/index.php');
	$zErrorLog->msg($http);
	$news = new HTTPRequest($http);
	$news->post=$post;
	if ($news->live()) {
		$output=$news->DownloadToString(true,false);
		$zErrorLog->msg('out='.$output);
	}

	//configuration - displays the configuration form
	//adminuser
	$post['zing']=zing_forum_hash();
	$post['action']='adminuser';
	$post['bbname']=get_bloginfo('name').' Forum';
	$post['bburl']=ZING_MYBB_URL;
	$post['websitename']=get_bloginfo('name');
	$post['websiteurl']=get_option('home');
	$post['cookiedomain']='';
	$post['cookiepath']='/';
	$post['contactemail']=get_bloginfo('admin_email');
	$http=zing_forum_http("mybb",'install/index.php');
	$zErrorLog->msg($http);
	$news = new HTTPRequest($http);
	$news->post=$post;
	if ($news->live()) {
		$output=$news->DownloadToString(true,false);
		$zErrorLog->msg('out='.$output);
	}

	//final
	$post['action']='final';
	$post['zing']=zing_forum_hash();
	$post['adminuser']=get_option('zing_forum_admin_login');//$current_user->data->user_login;
	$post['adminpass']=$post['adminpass2']=zing_forum_admin_password();
	/*
	if (get_option("zing_forum_login")=="MyBB") {
		$post['adminpass']=$post['adminpass2']=get_option("zing_forum_admin_password");
	} else {
		$post['adminpass']=$post['adminpass2']=substr($current_user->data->user_pass,1,25);
	}
	*/
	$post['adminemail']=$current_user->data->user_email;
	$http=zing_forum_http("mybb",'install/index.php');
	$zErrorLog->msg($http);
	$news = new HTTPRequest($http);
	$news->post=$post;
	if ($news->live()) {
		$output=$news->DownloadToString(true,false);
		$zErrorLog->msg('out='.$output);
	}

}

function zing_forum_mybb_upgrade() {
	global $zErrorLog,$current_user;

	//sync WP and MyBB users
	if (get_option("zing_forum_login")=="WP") {
		require_once(dirname(__FILE__).'/includes/wpusers.class.php');
		$wpusers=new wpusers();
		$wpusers->sync();
	}

	//login to MyBB
	$zErrorLog->msg('Login admin');
	$post=array();
	$post['action']='do_login';
	$post['zing']=zing_forum_hash();
	$post['username']=get_option('zing_forum_admin_login');
	$post['password']=zing_forum_admin_password();
	/*
	if (get_option('zing_forum_login')=="WP") {
		$post['username']=$current_user->data->user_login;
		$post['password']=substr($current_user->data->user_pass,1,25);
	} else {
		$post['username']=$current_user->data->user_login;
		$post['password']=get_option('zing_forum_admin_password');
	}
	*/
	$post['submit']='Login';
	$http=zing_forum_http("mybb",'install/upgrade.php');
	$zErrorLog->msg($http);
	$news = new HTTPRequest($http);
	$news->post=$post;
	if ($news->live()) {
		$output=$news->DownloadToString(true,false);
		$zErrorLog->msg('out='.$output);
	}

	//intro
	$post=array();
	$post['action']='intro';
	$post['zing']=zing_forum_hash();
	$post['submit']='Next &raquo;';
	$http=zing_forum_http("mybb",'install/upgrade.php');
	$zErrorLog->msg($http);
	$news = new HTTPRequest($http);
	$news->post=$post;
	if ($news->live()) {
		$output=$news->DownloadToString(true,false);
		$zErrorLog->msg('out='.$output);
	}

	//initial upgrade
	$post=array();
	$post['action']='doupgrade';
	$post['zing']=zing_forum_hash();
	$post['from']=16; //upgrades from 1.4.x
	$post['submit']='Next &raquo;';
	$http=zing_forum_http("mybb",'install/upgrade.php');
	$zErrorLog->msg($http);
	$news = new HTTPRequest($http);
	$news->post=$post;
	if ($news->live()) {
		$output=$news->DownloadToString(true,false);
		$zErrorLog->msg('out='.$output);
	}

	//revert templates
	$post=array();
	$post['action']='rebuildsettings';
	$post['zing']=zing_forum_hash();
	$post['submit']='Next &raquo;';
	$http=zing_forum_http("mybb",'install/upgrade.php');
	$zErrorLog->msg($http);
	$news = new HTTPRequest($http);
	$news->post=$post;
	if ($news->live()) {
		$output=$news->DownloadToString(true,false);
		$zErrorLog->msg('out='.$output);
	}

	//buildcaches
	$post=array();
	$post['action']='buildcaches';
	$post['zing']=zing_forum_hash();
	$post['submit']='Next &raquo;';
	$http=zing_forum_http("mybb",'install/upgrade.php');
	$zErrorLog->msg($http);
	$news = new HTTPRequest($http);
	$news->post=$post;
	if ($news->live()) {
		$output=$news->DownloadToString(true,false);
		$zErrorLog->msg('out='.$output);
	}

	//finish
	$post=array();
	$post['action']='finished';
	$post['zing']=zing_forum_hash();
	$post['submit']='Next &raquo;';
	$http=zing_forum_http("mybb",'install/upgrade.php');
	$zErrorLog->msg($http);
	$news = new HTTPRequest($http);
	$news->post=$post;
	if ($news->live()) {
		$output=$news->DownloadToString(true,false);
		$zErrorLog->msg('out='.$output);
	}
}
/**
 * Deactivation: nothing to do
 * @return void
 */
function zing_forum_deactivate() {
}

/**
 * Uninstallation: removal of database tables
 * @return void
 */
function zing_forum_uninstall() {
	global $wpdb;
	$prefix=$wpdb->prefix."zing_mybb_";
	$rows=$wpdb->get_results("show tables like '".$prefix."%'",ARRAY_N);
	foreach ($rows as $id => $row) {
		$query="drop table ".$row[0];
		$wpdb->query($query);
	}
	$ids=get_option("zing_forum_pages");
	$ida=explode(",",$ids);
	foreach ($ida as $id) {
		wp_delete_post($id);
	}
	delete_option("zing_forum_version");
	delete_option("zing_forum_pages");
	delete_option("zing_mybb_version");
	$fh = fopen(dirname(__FILE__).'/'.ZING_MYBB.'/inc/settings.php', 'w');
	fclose($fh);
}

/**
 * Main function handling content, footer and sidebars
 * @param $process
 * @param $content
 * @return unknown_type
 */
function zing_forum_main($process,$content="") {
	global $zing_forum_content;
	if ($zing_forum_content) {
		if ($zing_forum_content=="redirect") {
			header('Location:'.get_option('home').'/?page_id='.zing_forum_mainpage());
			die();
		}
		else {
			if ($_GET['action']=='logout') {
				unset($_SESSION['tmpfile']);
			}
			$content=$zing_forum_content;
			if (get_option('zing_forum_footer')=='Page') $content.=zing_footers(true);
		}
	}
	return $content;
}

function zing_forum_output($process) {
	global $post;
	global $wpdb;

	global $zing_forum_loaded,$zing_forum_to_include,$zing_forum_mode;

	switch ($process)
	{
		case "content":
			$cf=get_post_custom($post->ID);
			if (isset($_GET['zforum']))
			{
				$zing_forum_to_include=$_GET['zforum'];
				$zing_forum_mode="forum";
			}
			elseif (isset($_GET['zforumadmin']))
			{
				$zing_forum_to_include="admin/".$_GET['zforumadmin'];
				$zing_forum_mode="admin";
			}
			elseif (isset($_GET['module']))
			{
				$zing_forum_to_include="admin/index";
				$zing_forum_mode="admin";
			}
			elseif (isset($cf['zing_forum_page']))
			{
				if ($cf['zing_forum_page'][0]=='forum') {
					$zing_forum_to_include="index";
					$zing_forum_mode="forum";
				}
				if ($cf['zing_forum_page'][0]=='admin') {
					$zing_forum_to_include="admin/index";
					$zing_forum_mode="admin";
				}
			}
			else
			{
				return $content;
			}
			if (isset($cf['cat'])) {
				$_GET['cat']=$cf['cat'][0];
			}
			break;
	}
	if (strstr($zing_forum_to_include,'archive/index.php/')) $http=zing_forum_http("mybb",$zing_forum_to_include,$page);
	else $http=zing_forum_http("mybb",$zing_forum_to_include.'.php',$page);
	//echo '<br />'.$http.'<br />';
	$news = new HTTPRequest($http);

	if (!$news->curlInstalled()) return "cURL not installed";
	elseif (!$news->live()) return "A HTTP Error occured";
	else {
		$output=$news->DownloadToString(true,false);
		//die($output);
		$output=zing_forum_ob($output);
		if ($news->redirect) {
			header($output);
		}
		if (empty($output)) {
			return 'redirect';
		}
		else return '<!--forum:start--><div><br /></div>'.$output.'<!--forum:end-->';
	}
}

function zing_forum_http($module,$to_include="index",$page="",$key="") {
	global $wpdb;

	$vars="";
	if (!$to_include) $to_include="index";
	$http=ZING_MYBB_URL.'/';
	$http.= $to_include;
	$and="";
	if (count($_GET) > 0) {
		foreach ($_GET as $n => $v) {
			if ($n!="zforum" && $n!="page_id" && $n!="zforumadmin")
			{
				$vars.= $and.$n.'='.zing_urlencode($v);
				$and="&";
			}
		}
	}
	if (!strstr($to_include,'archive/index.php'))
	{
		$vars.=$and.'zing='.zing_urlencode(ZING_MYBB_URL);
		if (get_option('zing_forum_mybb_dbname')) {
			//$vars.='&zing_dbhost='.get_option('zing_forum_mybb_dbhost');
			$vars.='&zing_dbname='.get_option('zing_forum_mybb_dbname');
			//$vars.='&zing_dbuser='.get_option('zing_forum_mybb_dbuser');
			//$vars.='&zing_dbpassword='.get_option('zing_forum_mybb_dbpassword');
			$vars.='&zing_dbprefix='.get_option('zing_forum_mybb_dbprefix');
		} else {
			if (isset($wpdb->base_prefix)) {
				$infix=str_replace($wpdb->base_prefix,"",$wpdb->prefix);
				$vars.='&zing_prefix='.zing_urlencode($infix);
			}
		}
	}
	if ($vars) $http.='?'.$vars;
	//echo $http;
	return $http;
}

/**
 * Page content filter
 * @param $content
 * @return unknown_type
 */
function zing_forum_content($content) {
	return zing_forum_main("content",$content);
}


/**
 * Header hook: loads FWS addons and css files
 * @return unknown_type
 */
function zing_forum_header()
{
	global $zing_forum_content;
	global $zing_forum_menu;
	$output=zing_forum_output("content");

	zing_integrator_cut($output,'<div id="footer">','</div>'); //remove footer
	//zing_integrator_cut($output,'<div id="welcome">','</div>'); //remove admin login header
	zing_integrator_cut($output,'<span class="forgot_password">','</span>');

	$zing_forum_content=$output;

	echo '<script type="text/javascript" language="javascript">';
	echo "var zing_forum_url='".ZING_FORUM_URL."ajax/';";
	echo "var zing_forum_index='".get_option('home')."/index.php?';";
	//echo "function zing_url_enhance(s) { s=s.replace('.php?','&'); return zing_forum_index+'zforum='+s; }";
	echo "function zing_forum_url_ajax(s) { return zing_forum_url+s; }";
	echo '</script>';

	echo '<link rel="stylesheet" type="text/css" href="' . ZING_FORUM_URL . 'zing.css" media="screen" />';
}

function zing_forum_mainpage() {
	$ids=get_option("zing_forum_pages");
	$ida=explode(",",$ids);
	return $ida[0];

}
function zing_forum_ob($buffer) {
	global $zing_forum_mode,$wpdb;
	$self=str_replace('index.php','',$_SERVER['PHP_SELF']);
	$loc='http://'.$_SERVER['SERVER_NAME'];
	$mybbself=str_replace($loc,'',ZING_MYBB_URL);
	$home=get_option("home")."/";
	$admin=get_option('siteurl').'/wp-admin/';
	$ids=get_option("zing_forum_pages");
	$ida=explode(",",$ids);
	$pid=zing_forum_mainpage();

	if (get_option("zing_forum_login")=="WP") {
		if ($zing_forum_mode=="forum") {
			$buffer=str_replace(ZING_MYBB_URL.'/member.php?action=logout',wp_logout_url(),$buffer);
			$buffer=str_replace(ZING_MYBB_URL.'/member.php?action=login',wp_login_url(get_permalink()),$buffer);
			$buffer=str_replace(ZING_MYBB_URL.'/member.php?action=register',get_option('siteurl').'/wp-login.php?action=register',$buffer);
		} else {
			$buffer=str_replace('href="index.php?action=logout"','href="'.wp_logout_url().'"',$buffer);
		}
	}

	$buffer=str_replace(ZING_MYBB_URL."/admin/index.php",$home."index.php?page_id=".$pid."&zforumadmin=index",$buffer);
	$buffer=str_replace('href="'.ZING_MYBB_URL,'href="'.get_option('home'),$buffer);

	//css
	if (isset($wpdb->base_prefix)) $infix=str_replace($wpdb->base_prefix,"",$wpdb->prefix); else $infix="";
	//$buffer=str_replace(get_option('home').'/css.php?',ZING_MYBB_URL.'/css.php?zing_prefix='.$infix.'&',$buffer);
	//$buffer=str_replace(get_option('home').'/css.php?',ZING_MYBB_URL.'/css.php?zing_prefix='.$infix.'&',$buffer);
	$buffer=str_replace(get_option('home').'/css.php',ZING_FORUM_URL.'ajax/css.php',$buffer);

	//$buffer=str_replace('forumdisplay.php?',"index.php?zforum=forumdisplay&",$buffer);
	//$buffer=preg_replace('/([A-Za-z0-9_]*).php.(.*)/','index.php?zforum=$1&$2',$buffer);

	// replace by zing_integrator_tags($buffer,$bodyclass)
	//page header & footer
	$tagslist='head';
	$tags=explode(',',$tagslist);
	foreach ($tags as $tag)
	{
		$buffer=str_replace('<'.$tag,'<div id="zing'.$tag.'"',$buffer);
		$buffer=str_replace($tag.'>','div>',$buffer);
	}
	$buffer=str_replace('<body','<div class="zingbody"',$buffer);
	$buffer=str_replace('body>','div>',$buffer);

	$buffer=preg_replace('/<html.*>/','',$buffer);
	$buffer=preg_replace('/<.html>/','',$buffer);
	$buffer=preg_replace('/<meta.*>/','',$buffer);
	$buffer=preg_replace('/<title>.*<.title>/','',$buffer);
	$buffer=preg_replace('/<.DOCTYPE.*>/','',$buffer);
	//images
	$buffer=str_replace('src="images/','src="'.ZING_MYBB_URL.'/images/',$buffer);
	$buffer=str_replace('src="../images/','src="'.ZING_MYBB_URL.'/images/',$buffer);

	//hide logo
	$buffer=str_replace('class="logo"','class="logo" style="display:none"',$buffer);
	$buffer=str_replace('id="logo"','id="logo" style="display:none"',$buffer);
	if ($zing_forum_mode=="forum") {
		//popup
		$buffer=str_replace("MyBB.popupWindow('".ZING_MYBB_URL,"MyBB.popupWindow('".ZING_FORUM_URL."ajax/",$buffer);

		$buffer=str_replace($home.'cache/themes/',ZING_MYBB_URL.'/cache/themes/',$buffer); //global.css etc
		$buffer=str_replace("attachment.php",ZING_FORUM_URL.'attachment.php',$buffer);
		//special cases - quickLogin
		//$buffer=str_replace(ZING_MYBB_URL."/member.php?action=login",wp_login_url($home."?page_id".$pid),$buffer);
		$buffer=str_replace('onclick="MyBB.quickLogin(); return false;"','',$buffer);

		//pages
		$pageslist='index,misc,announcements,calendar,editpost,forumdisplay,global,managegroup,member,memberlist,modcp,moderation,newreply,newthread,online,polls,portal,printthread,private,ratethread,report,reputation,rss,search,sendthread,showteam,showthread,stats,syndication,usercp,usercp2,warnings,xmlhttp';
		$pages=explode(",",$pageslist);

		$buffer=str_replace('"'.$home.'index.php"','"'.$home.'index.php?page_id='.$pid.'"',$buffer);
		foreach ($pages as $page) {
			$buffer=str_replace(ZING_MYBB_URL."/".$page.".php?",$home."index.php?page_id=".$pid."&zforum=".$page."&",$buffer);
			$buffer=str_replace(ZING_MYBB_URL."/".$page.".php",$home."index.php?page_id=".$pid."&zforum=".$page,$buffer);
		}
		unset($pages[0]);
		foreach ($pages as $page) {
			$buffer=str_replace("./".$page.".php?",$home."index.php?page_id=".$pid."&zforum=".$page."&",$buffer);
			$buffer=str_replace($home.$page.".php?",$home."index.php?page_id=".$pid."&zforum=".$page."&",$buffer);
			$buffer=str_replace($home.$page.".php",$home."index.php?page_id=".$pid."&zforum=".$page,$buffer);
			$buffer=str_replace($page.".php?",$home."index.php?page_id=".$pid."&zforum=".$page."&",$buffer);
			$buffer=str_replace($page.".php",$home."index.php?page_id=".$pid."&zforum=".$page,$buffer);
		}
		//menu
		$buffer=str_replace('<div id="header">','<div>',$buffer);

		//javascripts
		$buffer=str_replace('../jscripts/',ZING_MYBB_URL.'/jscripts/',$buffer);
		$buffer=str_replace('./jscripts/',ZING_MYBB_URL.'/jscripts/',$buffer);
		$buffer=str_replace('src="jscripts/','src="'.ZING_MYBB_URL.'/jscripts/',$buffer);

		//captcha
		$buffer=str_replace('src="captcha.php?','src="'.ZING_MYBB_URL.'/captcha.php?',$buffer);

		//redirect form
		$buffer=str_replace('"index.php"','"'.$home.'index.php?page_id='.$pid.'"&zforum=index',$buffer);

		$buffer=preg_replace('/archive(.*).html/','index.php?page_id='.$pid.'&zforum=archive$1',$buffer);
		$buffer=str_replace($home.'archive/index.php',$home.'index.php?page_id='.$pid.'&zforum='.urlencode('archive/index'),$buffer);

		//help
		//$buffer=str_replace($home.'misc.php?action=help',$home."index.php?page_id=".$pid."&zforum=misc&action=help",$buffer);
	} else {
		//admin pages
		$pageslist='index,member';
		$mybb=ZING_MYBB_URL."/admin/";
		$pages=explode(",",$pageslist);
		foreach ($pages as $page) {
			$buffer=str_replace($mybb.$page.".php?",$admin."admin.php?page=zingiri-forum-admin&zforumadmin=".$page."&",$buffer);
			$buffer=str_replace($mybb.$page.".php",$admin."admin.php?page=zingiri-forum-admin&zforumadmin=".$page,$buffer);
			$buffer=str_replace($self.'wp-content/plugins/zingiri-forum/'.ZING_MYBB.'/admin/'.$page.".php?",$admin."admin.php?page=zingiri-forum-admin&zforumadmin=".$page.'&',$buffer);
			$buffer=str_replace('../'.$page.'.php?',$admin."admin.php?page=zingiri-forum-admin&zforumadmin=".$page."&",$buffer);
		}

		$buffer=str_replace('index.php?module=',$admin.'admin.php?page=zingiri-forum-admin&module=',$buffer);
		//admin style sheets
		$styles=array('default','sharepoint');
		foreach ($styles as $style) {
			$buffer=str_replace('./styles/'.$style.'/',ZING_MYBB_URL.'/admin/styles/zingiri/',$buffer);
			$buffer=str_replace('styles/'.$style.'/',ZING_MYBB_URL.'/admin/styles/zingiri/',$buffer);
		}
		//special cases
		$buffer=str_replace('"index.php"',$admin.'admin.php?page=zingiri-forum-admin&zforumadmin=index',$buffer);
		//		$buffer=str_replace(ZING_MYBB_URL,$home.'index.php?page_id='.$pid.'',$buffer);
		$buffer=str_replace('"'.get_option("home").'"','"'.$home.'index.php?page_id='.$pid.'"',$buffer);

		//iframe
		$buffer=str_replace('<iframe src="index.php?page_id='.$pid.'&module=tools/php_info','<iframe src="'.ZING_MYBB_URL.'/admin/index.php?module=tools/php_info',$buffer);
		$buffer=str_replace('<iframe src="'.$admin.'admin.php?page=zingiri-forum-admin','<iframe src="'.ZING_FORUM_URL.'ajax/admin/index.php?',$buffer);

		//javascripts
		$buffer=str_replace('../jscripts/',ZING_MYBB_URL.'/jscripts/',$buffer);
		$buffer=str_replace('./jscripts/',ZING_MYBB_URL.'/jscripts/',$buffer);
		$buffer=str_replace('/jscripts/tabs.js','/admin/jscripts/tabs.js',$buffer);
		$buffer=str_replace('<div id="menu">','<div id="zingmenu">',$buffer);

		//logout
		$buffer=str_replace('"index.php?action=logout"','"'.$admin.'admin.php?page=zingiri-forum-admin&zforumadmin=index&action=logout"',$buffer);
		$buffer=str_replace('&amp;','&',$buffer);

		//direct login
		$buffer=str_replace('action="'.$mybbself.'/admin/index.php','action="'.$admin.'admin.php',$buffer);

		//redirect form
		$buffer=str_replace('"index.php"','"'.$admin.'admin.php?page=zingiri-forum-cp"&zforum=index',$buffer);

		//task
		$buffer=str_replace(ZING_MYBB_URL.'task.php',ZING_FORUM_URL.'ajax/task.php',$buffer);
	}

	return $buffer;
}
/**
 * Initialization of page, action & page_id arrays
 * @return unknown_type
 */
function zing_forum_init()
{
	global $zing_forum_mode;

	ob_start();
	session_start();

	zing_forum_login();
	if (isset($_GET['zforum']))
	{
		$zing_forum_mode="forum";
	}
	elseif (isset($_GET['zforumadmin']) || isset($_GET['module']))
	{
		$zing_forum_mode="admin";
	}
}

function zing_forum_login() {
	global $current_user;
	if (is_user_logged_in() && get_option("zing_forum_login")=="WP") {
		zing_forum_login_user($current_user->data->user_login,$current_user->data->user_pass);
	}
}

function zing_forum_login_user($login,$password) {
	$post['action']='do_login';
	$post['username']=$login;
	$post['password']=substr($password,1,25);
	$post['url']="";
	$post['submit']='Login';
	//print_r($post);
	$http=zing_forum_http("mybb",'member.php');
	//echo '<br />'.$http;
	$news = new HTTPRequest($http);
	$news->post=$post;
	if ($news->live()) {
		$output=$news->DownloadToString(true,false);
		//echo '<br />out='.$output;
		//	if (strstr($output,'failed')) return false;
	}
	if (current_user_can("edit_plugins")) {
		//zing_forum_login_admin();
	}
	return true;
}

function zing_forum_login_admin() {
	global $current_user;

	$post['do']='login';
	$post['username']=get_option('zing_forum_admin_login');//$current_user->data->user_login;
	$post['password']=zing_forum_admin_password();//substr($current_user->data->user_pass,1,25);
	$post['url']="";
	$post['submit']='Login';
	$http=zing_forum_http("mybb",'admin/index.php');
	//echo '<br />'.$http;
	$news = new HTTPRequest($http);
	$news->post=$post;
	if ($news->live()) {
		$output=$news->DownloadToString(true,false);
		//echo '<br />out='.$output;
	}
}

function zing_forum_logout() {
	if (isset($_SESSION['tmpfile'])) {
		$ckfile=dirname(__FILE__).'/cache/'.$_SESSION['tmpfile'].md5($_SESSION['tmpfile']).'.tmp';
		unlink($ckfile);
		unset($_SESSION['tmpfile']);
	}
}

function zing_forum_check_password($check,$password,$hash,$user_id) {
	global $wpdb;

	$prefix=$wpdb->prefix."zing_mybb_";

	if (!$check) { //the user could be using his old password, pre Web Shop to Wordpress migration
		$user =  new WP_User($user_id);
		$query = sprintf("SELECT * FROM `".$prefix."users` WHERE `username`='%s'", $user->data->user_login);
		$sql = mysql_query($query) or die(mysql_error());
		if ($row = mysql_fetch_array($sql)) {
			if ($row['password']==md5(md5($row['salt']).md5($password))) return true;
		}
		else return false;
	} else return $check;
}

function zing_forum_profile_update($user_id) {
	if (class_exists('wpusers')) return;
	require(dirname(__FILE__).'/includes/wpusers.class.php');
	$user=new WP_User($user_id);
	$wpusers=new wpusers();
	$group=$wpusers->getForumGroup($user);
	$wpusers->updateForumUser($user->data->user_login,$user->data->user_pass,$user->data->user_email,$group);
}

function zing_forum_user_register($user_id) {
	//error_reporting(E_ALL & ~E_NOTICE);
	//ini_set('display_errors', '1');
	if (class_exists('wpusers')) return;
	require(dirname(__FILE__).'/includes/wpusers.class.php');
	$user=new WP_User($user_id);
	$wpusers=new wpusers();
	$group=$wpusers->getForumGroup($user);
	$wpusers->createForumUser($user->data->user_login,$user->data->user_pass,$user->data->user_email,$group);
}

function zing_forum_user_delete($user_id) {
	require(dirname(__FILE__).'/includes/wpusers.class.php');
	$user=new WP_User($user_id);
	$wpusers=new wpusers();
	$wpusers->deleteForumUser($user->data->user_login);
}

function zing_forum_admin_password() {
	$login=get_option('zing_forum_admin_login');
	if (get_option("zing_forum_login")=="MyBB") {
		$user_pass=get_option("zing_forum_admin_password");
	} else {
		$user=new WP_User($login);
		$user_pass=substr($user->data->user_pass,1,25);
	}
	return $user_pass;
}
?>